=== debian/changelog ===
armadillo (1:12.6.7+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:27:45 +0000

armadillo (1:12.6.7+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libarpack2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 07:32:24 +0000

armadillo (1:12.6.7+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Fri, 22 Dec 2023 11:47:19 +0530

armadillo (1:12.6.4+dfsg-2) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 27 Sep 2023 18:43:36 +0530

armadillo (1:12.6.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Thu, 31 Aug 2023 09:28:39 +0530

armadillo (1:12.6.1+dfsg-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Remove field Section on binary package libarmadillo11 that duplicates
    source.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dpkg-dev and libsuperlu-dev.
    + libarmadillo-dev: Drop versioned constraint on libsuperlu-dev in Depends.

  [ Kumar Appaiah ]
  * New upstream release
  * soname update to 12, add libarmadillo12 package
  * Override Lintian error saying that docs.html is autogenerated
  * Standards version is now 4.6.2 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Fri, 28 Jul 2023 19:06:12 +0530
