=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/quilt/quilt.make
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	dh_auto_configure --buildsystem=cmake --builddirectory=. -- -D INSTALL_LIB_DIR=lib -D CMAKE_INpppSTALL_PREFIX_INITIALIZED_TO_DEFAULT:BOOL=ON  . # specified to install to the debian/tmp directory.
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf debian/doc_gen
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f config.guess config.sub Makefile
	rm -f CMakeCache.txt cmake_install.cmake
	rm -rf CMakeFiles
	rm -f install_manifest.txt include/armadillo_bits/config.hpp examples/Makefile
	rm -f ArmadilloConfig.cmake ArmadilloConfigVersion.cmake
	rm -rf InstallFiles tmp *.o a.out
	dh_clean  --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig

install: build
	dh_testdir
	dh_testroot
	dh_prep --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig
	dh_installdirs
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install DESTDIR=debian/tmp

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp
	mkdir -p debian/libarmadillo-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	cp debian/tmp/usr/lib/pkgconfig/armadillo.pc debian/libarmadillo-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_compress -a -X.cpp
	dh_fixperms -a
	dh_makeshlibs -a -V
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: build install
# Currently no arch-independent packages

binary: binary-indep binary-arch
.PHONY: build clean binary-arch binary install
