## armadillo 12.8.2+dfsg

=== debian/changelog ===
armadillo (1:12.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sun, 05 May 2024 22:24:39 +0530
