## armadillo 14.0.1+dfsg

=== debian/changelog ===
armadillo (1:14.0.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Mon, 15 Jul 2024 19:13:30 +0530

armadillo (1:14.0.1+dfsg-1) experimental; urgency=medium

  * New upstream release
  * soname bump to 14

 -- Kumar Appaiah <akumar@debian.org>  Tue, 09 Jul 2024 08:50:45 +0530
