=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: armadillo
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
 Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
 Standards-Version: 4.6.2
@@ -14,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Suggests: libitpp-dev
-Depends: libarmadillo12 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
+Depends: libarmadillo14 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
 Replaces: libarmadillo-doc (<= 1.1.2-1)
 Conflicts: libarmadillo-doc
 Description: streamlined C++ linear algebra library - Headers
@@ -26,7 +25,7 @@
  .
  This package has the development libraries and headers for Armadillo.
 
-Package: libarmadillo12
+Package: libarmadillo14
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: streamlined C++ linear algebra library
