## armadillo 14.2.1+dfsg

=== debian/changelog ===
armadillo (1:14.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Standards version is 4.7.0 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Mon, 02 Dec 2024 15:20:38 +0530

armadillo (1:14.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Thu, 05 Sep 2024 22:30:08 +0530
