=== debian/changelog ===
armadillo (1:14.2.3+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Thu, 13 Feb 2025 07:24:13 +0530
