=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
 Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://arma.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/science-team/armadillo.git
