## armadillo 15.0.1+dfsg

=== debian/changelog ===
armadillo (1:15.0.1+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Update copyrights and bump soname
  * Remove missing icon from docs file
  * Standards version is now 4.7.2
  * Enable parallel build for tests

 -- Kumar Appaiah <akumar@debian.org>  Sun, 31 Aug 2025 20:41:07 +0530
