=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,11 @@
 CFLAGS+=$(CPPFLAGS)
 CXXFLAGS+=$(CPPFLAGS)
 
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+MAKEFLAGS += -j$(NUMJOBS)
+endif
+
 build: build-arch build-indep
 build-arch: build-stamp
 build-indep: build-stamp
@@ -15,6 +20,8 @@
 	dh_testdir
 	dh_auto_configure --buildsystem=cmake --builddirectory=. -- -D INSTALL_LIB_DIR=lib -D CMAKE_INpppSTALL_PREFIX_INITIALIZED_TO_DEFAULT:BOOL=ON  . # specified to install to the debian/tmp directory.
 	$(MAKE)
+	cd tests1 && LD_LIBRARY_PATH=.. ./smoke_test && cd ..
+	cd tests2 && $(MAKE) && LD_LIBRARY_PATH=.. ./main && cd ..
 	touch $@
 
 clean:
