=== debian/changelog ===
armadillo (1:15.2.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Thu, 06 Nov 2025 09:45:34 +0530

armadillo (1:15.2.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 29 Oct 2025 21:49:25 +0530
