=== debian/watch ===
version=4
opts=dversionmangle=s/\.dfsg\.\d+//,repacksuffix=+dfsg,compression=xz \
http://sf.net/arma/ armadillo-([0-9.][0-9.]+)\.tar\.xz debian uupdate
